"""
File name:		division.py

Description:	Primality testing by trial division

Author:			Eli Howey
				Written for Final Project
				MATH 56, Spring 2014

"""

from math import ceil, sqrt
import matplotlib.pyplot as plt
import time



def is_prime(n):
	"""
	is_prime(n)
	Determines whether n is prime using trial division
	"""
	# Case 1. Either 2 or 3, or divisible by 2 or 3
	if n == 2 or n == 3:
		return True
	elif n % 2 == 0 or n % 3 == 0:
		return False

	# Case 2. Divisible by some number of the form 6k +/- 1
	limit = int(ceil(sqrt(n))) + 1
	i,j = 5,7		# 6(1)+1, 6(1)-1

	while j < limit:
		if n % i == 0 or n % j == 0:
			return False
		else:
			i += 6
			j += 6

	return True
